# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [v0.1.3](https://github.com/ljharb/resumer/compare/v0.1.2...v0.1.3) - 2024-03-09

### Commits

- [types] use shared tsconfig [`ace3782`](https://github.com/ljharb/resumer/commit/ace3782bc7835d30cd4a3bc9c30babadb9f1ceea)
- [Robustness] use `call-bind` rather than `.apply` [`f43f860`](https://github.com/ljharb/resumer/commit/f43f860083eb3472a00dd470c0f2afecfc22f356)
- [Dev Deps] update `@types/node`, `tape`, `typescript`; add `@arethetypeswrong/cli` [`95580e2`](https://github.com/ljharb/resumer/commit/95580e2932087bee6b0bccf3454df156d3b6a67b)
- [Deps] update `@ljharb/through` [`c421b6f`](https://github.com/ljharb/resumer/commit/c421b6f03c8ee4914ef746ed08e6331cfaa2acdd)

## [v0.1.2](https://github.com/ljharb/resumer/compare/v0.1.1...v0.1.2) - 2024-01-26

### Commits

- [types] mark params as optional [`e128911`](https://github.com/ljharb/resumer/commit/e128911db66ad6927511f36df4b680453f1a5996)

## [v0.1.1](https://github.com/ljharb/resumer/compare/v0.1.0...v0.1.1) - 2024-01-26

### Commits

- [meta] add `types` field [`2fc9b25`](https://github.com/ljharb/resumer/commit/2fc9b2506e6ccaa381f122d8cb24aa3f44fa99fb)

## [v0.1.0](https://github.com/ljharb/resumer/compare/v0.0.1...v0.1.0) - 2024-01-25

### Commits

- [patch] add types [`8aa2f54`](https://github.com/ljharb/resumer/commit/8aa2f54a37a848b11e91f089891c46ae7d06aafd)
- [meta] update license text so GitHub can identify it [`d3b4604`](https://github.com/ljharb/resumer/commit/d3b4604a473623e8594d1a192d8110e6369e2cbd)
- [Dev Deps] update `concat-stream`, `tape` [`8f5f559`](https://github.com/ljharb/resumer/commit/8f5f5591058e099b6b0de29898712af526a5a3a2)
- [Dev Deps] update `aud`, `npmignore`, `tape` [`aab7103`](https://github.com/ljharb/resumer/commit/aab71039776d36379a466cd8adda24b999b4879d)
- [Deps] update `@ljharb/through` [`05c8993`](https://github.com/ljharb/resumer/commit/05c8993096d999f89e93e9a5277e48fbc4b64062)
- [meta] add `sideEffects` flag [`106b1f0`](https://github.com/ljharb/resumer/commit/106b1f0cb7e72778ff4fee4e0e3695c4e814b2ad)

## [v0.0.1](https://github.com/ljharb/resumer/compare/v0.0.0...v0.0.1) - 2023-07-17

### Commits

- [meta] add scripts, dev deps, linting; switch from travis to GHA [`ddf267c`](https://github.com/ljharb/resumer/commit/ddf267c051fb1756e403929cebe383fafb069f43)
- [meta] rename package to scoped [`e63afa4`](https://github.com/ljharb/resumer/commit/e63afa4679e28c86e018c92aad51372b54492e5e)
- [Dev Deps] update `concat-stream`, `tape` [`b3ef087`](https://github.com/ljharb/resumer/commit/b3ef08792acf6c0cf0632c8ee5923a6c740f6946)
- [Deps] use `@ljharb/through` instead of `through` [`b80960c`](https://github.com/ljharb/resumer/commit/b80960ced2935c23baa4be90f1d65d5ef0abc27b)

## v0.0.0 - 2023-07-17

### Commits

- package.json etc [`d953649`](https://github.com/ljharb/resumer/commit/d9536492cca8a5769dce08e3b689d9a403e3930a)
- example and tests [`17f59f5`](https://github.com/ljharb/resumer/commit/17f59f50fa9d080f408d358886af7593dd39d52b)
- passing through test [`13acd46`](https://github.com/ljharb/resumer/commit/13acd46f7387bd7b9536a9995df0ae562b93b10e)
- ripped out of bashful [`848b875`](https://github.com/ljharb/resumer/commit/848b8755f5d89c7287e48d98b6f140553afbaf1e)
- docs [`dec9a86`](https://github.com/ljharb/resumer/commit/dec9a86f76222d7df2e7ff6865d82874bc4df8d8)
- more docs [`9ea2b5a`](https://github.com/ljharb/resumer/commit/9ea2b5ab4e414e8489edc35efcfbc4f70749dcab)
- pause/resume test [`7f52e27`](https://github.com/ljharb/resumer/commit/7f52e27a8b24c9223a8a1a55a8cb887b36f08f9c)
- using testling [`5178aa6`](https://github.com/ljharb/resumer/commit/5178aa6c2836493afead483b22909fff5774707c)
- badges [`2a0225a`](https://github.com/ljharb/resumer/commit/2a0225ad78643a88af86ba70e44977a4f5d681fa)
